﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ESRI.ArcGIS.Geodatabase;
using ESRI.ArcGIS.esriSystem;

namespace Postarc.Geodatabase
{
    public class FieldInfo : IFieldInfo
    {
        protected string alias = null;
        protected INumberFormat numberFormat = null;
        protected bool visible = true;

        public static IFieldInfo Create(IField field)
        {
            return new FieldInfo(field);
        }

        protected FieldInfo(IField field)
        {
            Alias = field.AliasName;
            switch (field.Type)
            {
                case esriFieldType.esriFieldTypeInteger:
                case esriFieldType.esriFieldTypeSmallInteger:
                    this.numberFormat = new NumericFormatClass();
                    break;
            }
        }

        public string Alias
        {
            get
            {
                return this.alias;
            }
            set
            {
                this.alias = value;
            }
        }

        public INumberFormat NumberFormat
        {
            get
            {
                return this.numberFormat;
            }
            set
            {
                this.numberFormat = value;
            }
        }

        public bool Visible
        {
            get
            {
                return this.visible;
            }
            set
            {
                this.visible = value;
            }
        }

        public string get_AsString(object value)
        {
            if (value == null)
            {
                return "<NULL>";
            }
            else
            {
                return value.ToString();
            }
        }
    }
}
